import "Turbine"

AhCmd = Turbine.ShellCommand();

function AhCmd:Execute(cmd, args)
	val1, opr, val2 = args:match("^([%d\.,]+)\s*([^%d ])\s*([%d\.,]+)$");
	if (val1 ~= nil and val2 ~= nil and opr ~= nil) then
		AhCmd:AhCal(val1, opr, val2);
	else
		args = split(args, " ");
		if (args[1] and args[2] ~= nil) then
			if (string.len(math.floor(args[1])) == string.len(math.floor(args[2]))) then
				if (args[1] < args[2]) then
					arg1 = args[2];
					arg2 = args[1];
				elseif (args[1] >= args[2]) then
					arg1 = args[1];
					arg2 = args[2];
				end
			elseif (string.len(math.floor(args[1])) < string.len(math.floor(args[2]))) then
				arg1 = args[2];
				arg2 = args[1];
			elseif (string.len(math.floor(args[1])) > string.len(math.floor(args[2]))) then
				arg1 = args[1];
				arg2 = args[2];
			end
		else
			arg1 = args[1];
			arg2 = args[2];
		end
		if (type(tonumber(arg1)) == "number"  and  arg2 == nil) then
			AhCmd:AucPri(arg1);
		elseif (type(tonumber(arg1)) == "number" and type(tonumber(arg2)) == "number") then
			AhCmd:AucPri(arg1, arg2);
		else
			AhCmd:GetHelp();
		end
	end
end

function AhCmd:AucPri(buyout, bid)
	if (bid == nil) then
		Turbine.Shell.WriteLine( "<rgb=#00FF00>Set Buyout to</rgb> <rgb=#FFFF00>" .. math.floor( ( buyout/0.95)*(10^2) )/(10^2) .. "s</rgb> <rgb=#00FF00>to get</rgb> <rgb=#80FF00>" .. buyout .. "s</rgb>" );
	else
		Turbine.Shell.WriteLine( "<rgb=#00FF00>Set Starting Bid to</rgb> <rgb=#FFBF00>" .. math.floor( ( bid/0.95)*(10^2) )/(10^2) .. "s</rgb><rgb=#00FF00> and Buyout to</rgb> <rgb=#FFFF00>" .. math.floor( ( buyout/0.95)*(10^2) )/(10^2) .. "s</rgb> <rgb=#00FF00>to get between</rgb> <rgb=#80FF00>" .. bid .. "s</rgb> <rgb=#00FF00>and</rgb> <rgb=#80FF00>" .. buyout .. "s</rgb>" );
	end
end

function AhCmd:GetHelp()
	Turbine.Shell.WriteLine( "Syntax: /ah <price>" );
	Turbine.Shell.WriteLine( "Calc Syntax: /ah <value><operation><value2>" );
	Turbine.Shell.WriteLine( "Operations: +, -, *, /, ^, %" );
end

function AhCmd:AhCal(val1, opr, val2)
	if (opr == "+") then
		eval = val1+val2;
	elseif (opr == "-") then
		eval = val1-val2;
	elseif (opr == "*" or opr == "x") then
		eval = val1*val2;
	elseif (opr == "/") then
		eval = val1/val2;
	elseif (opr == "^") then
		eval = val1^val2;
	elseif (opr == "%") then
		eval = val1%val2;
	end
	if (eval ~= nil) then
		Turbine.Shell.WriteLine("<rgb=#00FF00>" .. val1 .. "</rgb><rgb=#FFFF00>" .. opr .. "</rgb><rgb=#00FF00>" .. val2 .. "</rgb> <rgb=#FFBF00>=</rgb> <rgb=#80FF00>" .. eval .. "</rgb>");
	else
		AhCmd:GetHelp();
	end
end

function split(pString, pPattern)
	local Table = {} -- NOTE: use {n = 0} in Lua-5.0
	local fpat = "(.-)" .. pPattern
	local last_end = 1
	local s, e, cap = pString:find(fpat, 1)
	while s do
		if s ~= 1 or cap ~= "" then
			table.insert(Table,cap)
		end
		last_end = e+1
		s, e, cap = pString:find(fpat, last_end)
	end
	if last_end <= #pString then
		cap = pString:sub(last_end)
		table.insert(Table, cap)
	end
	return Table
end

Turbine.Shell.AddCommand( "ah", AhCmd );